fs = require 'fs'
express = require 'express'
path = require 'path'
coffee = require 'coffee-middleware'
SshServer = require 'hubot-ssh-server'
{TextMessage, EnterMessage, User, Adapter} = require 'hubot'

class Sshbot extends Adapter

  send: (envelope, strings...) ->
    envelope.user.output.add("Hubot: #{str}") for str in strings

  emote: (envelope, strings...) ->
    @send envelope, "* #{str}" for str in strings

  reply: (envelope, strings...) ->
    @send envelope, strings...

  root: ->
    @_root ||= path.resolve __dirname, "../"

  run: ->
    self = @
    server = new SshServer
    server.start(@port())

    server.on "message", (stream, msg)->
      self.receive new TextMessage(stream, msg, "message-#{Date.now()}")
      console.log "Received #{msg}"

    @emit 'connected'

  port: ->
    process.env.HUBOT_SSH_PORT || 3050

exports.use = (robot) ->
  new Sshbot robot
